var requirejs = require('requirejs');
requirejs.config({
    nodeRequire: require
});

var NetOS = requirejs(['NetOS','util','node-static','fs'], function( NetOS, util, nstatic, fs ){
    var file1 = new(nstatic.Server)('/home/jaredbarnes/server1/files');
    var file2 = new(nstatic.Server)('/home/jaredbarnes/server2/files');
    
    var netOS1 = new NetOS({
        root: "/home/jaredbarnes/server1"
    });
    
    var netOS2 = new NetOS({
        root: "/home/jaredbarnes/server2"
    });
    
    netOS1.listen(8001, '127.0.0.1', function(){});
    netOS2.listen(8002, '127.0.0.1', function(){
       
        netOS1.on('fs.find', function(e){
        
            var root = "/home/jaredbarnes/server1/files"
            var path = e.path;
            
            fs.stat(root+path, function(err, stat){
            
                if (!err){
                    var event = netOS1.Event('fs.'+path);
                    event.host = netOS1.host+":"+netOS1.port;
                
                    netOS1.emit(event);
                    console.log("File found on server "+netOS1.host+":"+netOS1.port+".");
                } else {
                    console.log("File not found on server "+netOS1.host+":"+netOS1.port+".");
                }
            
            });
        
        });
    
        netOS2.on('fs.find', function(e){
        
            var root = "/home/jaredbarnes/server2/files"
            var path = e.path;
            
            fs.stat(root+path, function(err, stat){
            
                if (!err){
                    var event = netOS2.Event('fs.'+path);
                    event.host = netOS2.host+":"+netOS2.port;
                
                    netOS2.emit(event);
                    console.log("File found on server "+netOS2.host+":"+netOS2.port+".");
                } else {
                    console.log("File not found on server "+netOS2.host+":"+netOS2.port+".");
                }
            
            });
        
        });
    
        var event = new netOS2.Event("fs.find", function(){}, function(e){
            //console.log("DONE");
            });
            
        event.path = '/bryceissmart.txt';
        netOS2.emit(event);
    
        netOS2.on('fs.'+event.path, function(e){
            var count = 0;
           
            if (e.host === '127.0.0.1:8001'){
                var txt = function(e){
                    count++;
                    var request = e.request;
                    var response = e.response;
                    
                    request.on('end', function(){
                        file1.serve(request, response);
                    });
                    
                    if (count >= 3){
                        netOS1.eventServer.removeListener('.txt', txt);
                    }
                    return false;
                };
                
                netOS1.eventServer.on('.txt', txt);
            } else {
                var txt2 = function(e){
                    count++;
                    var request = e.request;
                    var response = e.response;
                    
                    request.on('end', function(){
                        file2.serve(request, response);
                    });
                    
                    if (count >= 3){
                        netOS2.eventServer.removeListener('.txt', txt2);
                    }
                    return false;
                };
                netOS2.eventServer.on('.txt', txt2);
            }
            
        });
       
    });
    
    netOS1.eventServer.on('.html', function(e){
        var request = e.request;
        var response = e.response;
        
        request.on('end', function () {
            //
            // Serve files!
            //
            file1.serve(request, response);
        });
        return false;
    });
    
});

